# -*- coding: utf-8 -*-

"""
cookiesapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from cookiesapi.models.media_item import MediaItem


class DualFormatGraphic(object):

    """Implementation of the 'DualFormatGraphic' model.

    Asset which is capable of specifying both a vector and raster form of a
    given asset.

    Attributes:
        raster (MediaItem): Raster version of this graphic.
        vector (MediaItem): Vector version of this graphic.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "raster": 'raster',
        "vector": 'vector'
    }

    def __init__(self,
                 raster=None,
                 vector=None):
        """Constructor for the DualFormatGraphic class"""

        # Initialize members of the class
        self.raster = raster
        self.vector = vector

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary
        raster = MediaItem.from_dictionary(dictionary.get('raster')) if dictionary.get('raster') else None
        vector = MediaItem.from_dictionary(dictionary.get('vector')) if dictionary.get('vector') else None

        # Return an object of this model
        return cls(raster,
                   vector)
