# -*- coding: utf-8 -*-

"""
cookiesapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

import json
import dateutil.parser

from tests.controllers.controller_test_base import ControllerTestBase
from tests.test_helper import TestHelper
from tests.http_response_catcher import HttpResponseCatcher
from cookiesapi.api_helper import APIHelper
from cookiesapi.controllers.strains_controller import StrainsController


class StrainsControllerTests(ControllerTestBase):

    @classmethod
    def setUpClass(cls):
        super(StrainsControllerTests, cls).setUpClass()
        cls.response_catcher = HttpResponseCatcher()
        cls.controller = StrainsController(cls.config, cls.response_catcher)

    # Fetch a generic list of all strains.
    def test_list_strains(self):
        # Parameters for the API call
        brand = None

        # Perform the API call through the SDK function
        result = self.controller.list_strains(brand)

        # Test response code
        self.assertEquals(self.response_catcher.response.status_code, 200)

    # List strains, filtered by brand COOKIES.
    def test_list_strains_cookies(self):
        # Parameters for the API call
        brand = 'COOKIES'

        # Perform the API call through the SDK function
        result = self.controller.list_strains(brand)

        # Test response code
        self.assertEquals(self.response_catcher.response.status_code, 200)

    # List strains, filtered by brand LEMONNADE.
    def test_list_strains_lemonnade(self):
        # Parameters for the API call
        brand = 'LEMONNADE'

        # Perform the API call through the SDK function
        result = self.controller.list_strains(brand)

        # Test response code
        self.assertEquals(self.response_catcher.response.status_code, 200)

